<?php
/*
Plugin Name: İncil.info Ayetler
Plugin URI: http://incil.info/eklentiler/wordpress
Description: Ayetleri bulup link şekline çevirir
Version: 0.3
Author: Caleb Maclennan
Author URI: http://alerque.com
License: GPL2
*/
/*  Copyright 2010  Caleb Maclennan  (email : caleb@incil.info)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function incil_karakterdonustur ($string) {
	$trchars = array('ı' => 'i', 'ç' => 'c', 'ş' => 's', 'ö' => 'o', 'ü' => 'u', 'â' => 'a', 'ğ' => 'g', 'İ' => 'I', 'Ç' => 'C', 'Ş' => 'S', 'Ö' => 'O', 'Ü' => 'U', 'Â' => 'A', 'Ğ' => 'G');
	$regex = array('search' => array(), 'replace' => array());
	foreach ($trchars as $char => $tran) {
		$regex['search'][] = "!$char!";
		$regex['replace'][] = $tran;
	}
	$string = preg_replace($regex['search'], $regex['replace'], $string);
	return $string;
}

function incil_urlcevir ($matches) {
	$url = preg_replace("![']+!", '', $matches[0]);
	$url = preg_replace("!\s+!", '+', $url);
	$url = incil_karakterdonustur($url);
	$yenipencere = get_option('incil_yenipencere') ? 'target="_blank"' : '';
	return "<a class=\"incil_info_ayet\" href=\"http://incil.info/arama/$url\" incilReferans=\"$url\" $yenipencere>$matches[0]</a>";
}


function incil_init() {
	if (get_option('incil_aracipucu')) {
		wp_register_script('incilinfo', WP_PLUGIN_URL . '/incilinfo/incil_ayet.js');
		wp_enqueue_script('incilinfo');
		wp_register_style('incilinfo', WP_PLUGIN_URL . '/incilinfo/incil_stil.css');
		wp_enqueue_style('incilinfo');
	}
}

function incil_ara ($metin='') {
	$gormezdengel = array(
			'<a\s+href.*?<\/a>',
			'<pre>.*<\/pre>',
			'<code>.*<\/code>',
			'<(?:[^<>\s]*)(?:\s[^<>]*){0,1}>'
		);
	foreach ($gormezdengel as $k => $v) {
		$gormezdengel[$k] = "(?:$v)";
	}
	$spliton = '/('.join($gormezdengel, '|').')/i';
	$split = preg_split($spliton, $metin, -1, PREG_SPLIT_DELIM_CAPTURE);
	$cevirmis = '';
	foreach ($split as $k => $v) {
		$cevirmis .= (preg_match($spliton, $v)) ? $v : incil_cevir($v);
	}
	return $cevirmis;
}

function incil_cevir ($metin='') {
	$kitapregex = "(yarat(?:i|İ|ı)l(?:i|İ|ı)(?:s|ş|Ş)|m(?:i|İ|ı)s(?:i|İ|ı)r(?:'|’|&#8217;)?dan\s+(?:c|ç|Ç)(?:i|İ|ı)k(?:i|İ|ı)(?:s|ş|Ş)|lev(?:i|İ|ı)l(?:i|İ|ı)ler|c(?:o|ö|Ö)lde\s+say(?:i|İ|ı)m|yasa(?:'|’|&#8217;)?n(?:i|İ|ı)n\s+tekrar(?:i|İ|ı)|ye(?:s|ş|Ş)u|hakimler|rut|(?:(?:[123]|bir(inci)?|iki(nci)?|(?:u|ü|Ü)c((?:u|ü|Ü)nc(?:u|ü|Ü))?)\.?\s+?)samuel|(?:(?:[123]|bir(inci)?|iki(nci)?|(?:u|ü|Ü)c((?:u|ü|Ü)nc(?:u|ü|Ü))?)\.?\s+?)krallar|(?:(?:[123]|bir(inci)?|iki(nci)?|(?:u|ü|Ü)c((?:u|ü|Ü)nc(?:u|ü|Ü))?)\.?\s+?)tarihler|ezra|nehemya|ester|ey(?:u|ü|Ü)p|mezmur|mezmurlar|s(?:u|ü|Ü)leyman(?:'|’|&#8217;)?(?:i|İ|ı)n\s+(?:o|ö|Ö)zdeyi(?:s|ş|Ş)leri|vaiz|ezgiler\s+ezgisi|ye(?:s|ş|Ş)aya|yeremya|a(?:g|ğ|Ğ)itlar|hezekiel|daniel|hosea|yoel|amos|ovadya|yunus|mika|nahum|habakkuk|sefanya|hagay|zekeriya|malaki|matta|markos|luka|yuhanna|el(?:c|ç|Ç)ilerin\s+i(?:s|ş|Ş)leri|romal(?:i|İ|ı)lar|(?:(?:[123]|bir(inci)?|iki(nci)?|(?:u|ü|Ü)c((?:u|ü|Ü)nc(?:u|ü|Ü))?)\.?\s+?)korintililer|galatyal(?:i|İ|ı)lar|efesliler|filipililer|koloseliler|(?:(?:[123]|bir(inci)?|iki(nci)?|(?:u|ü|Ü)c((?:u|ü|Ü)nc(?:u|ü|Ü))?)\.?\s+?)selanikiler|(?:(?:[123]|bir(inci)?|iki(nci)?|(?:u|ü|Ü)c((?:u|ü|Ü)nc(?:u|ü|Ü))?)\.?\s+?)timoteos|titus|filimon|(?:i|İ|ı)braniler|yakup|(?:(?:[123]|bir(inci)?|iki(nci)?|(?:u|ü|Ü)c((?:u|ü|Ü)nc(?:u|ü|Ü))?)\.?\s+?)petrus|(?:(?:[123]|bir(inci)?|iki(nci)?|(?:u|ü|Ü)c((?:u|ü|Ü)nc(?:u|ü|Ü))?)\.?\s+?)yuhanna|yahuda|vahiy)";
	$ayetregex = "[0-9]*:?[-,0-9]*[0-9]";
	$metin = preg_replace_callback("!($kitapregex\s+$ayetregex)!i", 'incil_urlcevir', $metin);
	return $metin;
}

function incil_secenek_menusu () {
		add_options_page('Ayet linkleri', 'Ayet linkleri', 'manage_options', 'incil_secenek_menusu', 'incil_secenekler');
		add_action('admin_init', 'incil_secenekleri_kayityap');
}

function incil_secenekleri_kayityap () {
	register_setting('incil_secenekler', 'incil_aracipucu');
	register_setting('incil_secenekler', 'incil_yenipencere');
}

function incil_secenekler () {
	if (!current_user_can('manage_options')) {
		wp_die( __('Bu sayfaya görmek için gerekli izinin yok.') );
	}
	include (dirname(__FILE__).'/incil_secenekler.php');
}

add_action('init', 'incil_init');
add_action('admin_menu', 'incil_secenek_menusu');
add_filter('the_content', 'incil_ara');
add_filter('comment_text', 'incil_ara');
